﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel;

namespace TheTeachersTimesaverCore.Types
{
    public class CourseScheduleInfo : BaseInfo, IDataErrorInfo
    {

        #region Properties

        #region Id
        /// <summary>
        /// Store for the Id property.</summary>
        private String _Id;
        /// <summary>
        /// Gets or sets Id property.</summary>
        [DataObjectField(true)]
        public String Id
        {
            get { return _Id; }
            set
            {
                if (_Id == value) return;
                _Id = value;
                OnPropertyChanged("Id");
            }
        }
        #endregion //Id

        #region CourseId
        /// <summary>
        /// Store for the CourseId property.</summary>
        private String _CourseId;
        /// <summary>
        /// Gets or sets CourseId property.</summary>
        [DataObjectField(false)]
        public String CourseId
        {
            get { return _CourseId; }
            set
            {
                if (_CourseId == value) return;
                _CourseId = value;
                OnPropertyChanged("CourseId");
            }
        }
        #endregion //CourseId

        #region ScheduleDescription
        /// <summary>
        /// Store for the ScheduleDescription property.</summary>
        private String _ScheduleDescription;
        /// <summary>
        /// Gets or sets ScheduleDescription property.</summary>
        [DataObjectField(false)]
        public String ScheduleDescription
        {
            get { return _ScheduleDescription; }
            set
            {
                if (_ScheduleDescription == value) return;
                _ScheduleDescription = value;
                OnPropertyChanged("ScheduleDescription");
            }
        }
        #endregion //ScheduleDescription

        #region IsRolling
        /// <summary>
        /// Store for the IsRolling property.</summary>
        private Boolean _IsRolling;
        /// <summary>
        /// Gets or sets IsRolling property.</summary>
        [DataObjectField(false)]
        public Boolean IsRolling
        {
            get { return _IsRolling; }
            set
            {
                if (_IsRolling == value) return;
                _IsRolling = value;
                OnPropertyChanged("IsRolling");
            }
        }
        #endregion //IsRolling

        #region IsDay1Enabled
        /// <summary>
        /// Store for the IsDay1Enabled property.</summary>
        private Boolean _IsDay1Enabled;
        /// <summary>
        /// Gets or sets IsDay1Enabled property.</summary>
        [DataObjectField(false)]
        public Boolean IsDay1Enabled
        {
            get { return _IsDay1Enabled; }
            set
            {
                if (_IsDay1Enabled == value) return;
                _IsDay1Enabled = value;
                OnPropertyChanged("IsDay1Enabled");
            }
        }
        #endregion //IsDay1Enabled

        #region IsDay2Enabled
        /// <summary>
        /// Store for the IsDay2Enabled property.</summary>
        private Boolean _IsDay2Enabled;
        /// <summary>
        /// Gets or sets IsDay2Enabled property.</summary>
        [DataObjectField(false)]
        public Boolean IsDay2Enabled
        {
            get { return _IsDay2Enabled; }
            set
            {
                if (_IsDay2Enabled == value) return;
                _IsDay2Enabled = value;
                OnPropertyChanged("IsDay2Enabled");
            }
        }
        #endregion //IsDay2Enabled

        #region IsDay3Enabled
        /// <summary>
        /// Store for the IsDay3Enabled property.</summary>
        private Boolean _IsDay3Enabled;
        /// <summary>
        /// Gets or sets IsDay3Enabled property.</summary>
        [DataObjectField(false)]
        public Boolean IsDay3Enabled
        {
            get { return _IsDay3Enabled; }
            set
            {
                if (_IsDay3Enabled == value) return;
                _IsDay3Enabled = value;
                OnPropertyChanged("IsDay3Enabled");
            }
        }
        #endregion //IsDay3Enabled

        #region IsDay4Enabled
        /// <summary>
        /// Store for the IsDay4Enabled property.</summary>
        private Boolean _IsDay4Enabled;
        /// <summary>
        /// Gets or sets IsDay4Enabled property.</summary>
        [DataObjectField(false)]
        public Boolean IsDay4Enabled
        {
            get { return _IsDay4Enabled; }
            set
            {
                if (_IsDay4Enabled == value) return;
                _IsDay4Enabled = value;
                OnPropertyChanged("IsDay4Enabled");
            }
        }
        #endregion //IsDay4Enabled

        #region IsDay5Enabled
        /// <summary>
        /// Store for the IsDay5Enabled property.</summary>
        private Boolean _IsDay5Enabled;
        /// <summary>
        /// Gets or sets IsDay5Enabled property.</summary>
        [DataObjectField(false)]
        public Boolean IsDay5Enabled
        {
            get { return _IsDay5Enabled; }
            set
            {
                if (_IsDay5Enabled == value) return;
                _IsDay5Enabled = value;
                OnPropertyChanged("IsDay5Enabled");
            }
        }
        #endregion //IsDay5Enabled

        #region IsDay6Enabled
        /// <summary>
        /// Store for the IsDay6Enabled property.</summary>
        private Boolean _IsDay6Enabled;
        /// <summary>
        /// Gets or sets IsDay6Enabled property.</summary>
        [DataObjectField(false)]
        public Boolean IsDay6Enabled
        {
            get { return _IsDay6Enabled; }
            set
            {
                if (_IsDay6Enabled == value) return;
                _IsDay6Enabled = value;
                OnPropertyChanged("IsDay6Enabled");
            }
        }
        #endregion //IsDay6Enabled

        #region IsDay7Enabled
        /// <summary>
        /// Store for the IsDay7Enabled property.</summary>
        private Boolean _IsDay7Enabled;
        /// <summary>
        /// Gets or sets IsDay7Enabled property.</summary>
        [DataObjectField(false)]
        public Boolean IsDay7Enabled
        {
            get { return _IsDay7Enabled; }
            set
            {
                if (_IsDay7Enabled == value) return;
                _IsDay7Enabled = value;
                OnPropertyChanged("IsDay7Enabled");
            }
        }
        #endregion //IsDay7Enabled

        #region IsDay1TimeSynced
        /// <summary>
        /// Store for the IsDay1TimeSynced property.</summary>
        private Boolean _IsDay1TimeSynced = true;
        /// <summary>
        /// Gets or sets IsDay1TimeSynced property.</summary>
        [DataObjectField(false)]
        public Boolean IsDay1TimeSynced
        {
            get { return _IsDay1TimeSynced; }
            set
            {
                if (_IsDay1TimeSynced == value) return;
                _IsDay1TimeSynced = value;
                OnPropertyChanged("IsDay1TimeSynced");
            }
        }
        #endregion //IsDay1TimeSynced

        #region IsDay2TimeSynced
        /// <summary>
        /// Store for the IsDay2TimeSynced property.</summary>
        private Boolean _IsDay2TimeSynced = true;
        /// <summary>
        /// Gets or sets IsDay2TimeSynced property.</summary>
        [DataObjectField(false)]
        public Boolean IsDay2TimeSynced
        {
            get { return _IsDay2TimeSynced; }
            set
            {
                if (_IsDay2TimeSynced == value) return;
                _IsDay2TimeSynced = value;
                OnPropertyChanged("IsDay2TimeSynced");
            }
        }
        #endregion //IsDay2TimeSynced

        #region IsDay3TimeSynced
        /// <summary>
        /// Store for the IsDay3TimeSynced property.</summary>
        private Boolean _IsDay3TimeSynced = true;
        /// <summary>
        /// Gets or sets IsDay3TimeSynced property.</summary>
        [DataObjectField(false)]
        public Boolean IsDay3TimeSynced
        {
            get { return _IsDay3TimeSynced; }
            set
            {
                if (_IsDay3TimeSynced == value) return;
                _IsDay3TimeSynced = value;
                OnPropertyChanged("IsDay3TimeSynced");
            }
        }
        #endregion //IsDay3TimeSynced

        #region IsDay4TimeSynced
        /// <summary>
        /// Store for the IsDay4TimeSynced property.</summary>
        private Boolean _IsDay4TimeSynced = true;
        /// <summary>
        /// Gets or sets IsDay4TimeSynced property.</summary>
        [DataObjectField(false)]
        public Boolean IsDay4TimeSynced
        {
            get { return _IsDay4TimeSynced; }
            set
            {
                if (_IsDay4TimeSynced == value) return;
                _IsDay4TimeSynced = value;
                OnPropertyChanged("IsDay4TimeSynced");
            }
        }
        #endregion //IsDay4TimeSynced

        #region IsDay5TimeSynced
        /// <summary>
        /// Store for the IsDay5TimeSynced property.</summary>
        private Boolean _IsDay5TimeSynced = true;
        /// <summary>
        /// Gets or sets IsDay5TimeSynced property.</summary>
        [DataObjectField(false)]
        public Boolean IsDay5TimeSynced
        {
            get { return _IsDay5TimeSynced; }
            set
            {
                if (_IsDay5TimeSynced == value) return;
                _IsDay5TimeSynced = value;
                OnPropertyChanged("IsDay5TimeSynced");
            }
        }
        #endregion //IsDay5TimeSynced

        #region IsDay6TimeSynced
        /// <summary>
        /// Store for the IsDay6TimeSynced property.</summary>
        private Boolean _IsDay6TimeSynced = true;
        /// <summary>
        /// Gets or sets IsDay6TimeSynced property.</summary>
        [DataObjectField(false)]
        public Boolean IsDay6TimeSynced
        {
            get { return _IsDay6TimeSynced; }
            set
            {
                if (_IsDay6TimeSynced == value) return;
                _IsDay6TimeSynced = value;
                OnPropertyChanged("IsDay6TimeSynced");
            }
        }
        #endregion //IsDay6TimeSynced

        #region IsDay7TimeSynced
        /// <summary>
        /// Store for the IsDay7TimeSynced property.</summary>
        private Boolean _IsDay7TimeSynced = true;
        /// <summary>
        /// Gets or sets IsDay7TimeSynced property.</summary>
        [DataObjectField(false)]
        public Boolean IsDay7TimeSynced
        {
            get { return _IsDay7TimeSynced; }
            set
            {
                if (_IsDay7TimeSynced == value) return;
                _IsDay7TimeSynced = value;
                OnPropertyChanged("IsDay7TimeSynced");
            }
        }
        #endregion //IsDay7TimeSynced

        #region Day1Start
        /// <summary>
        /// Store for the Day1Start property.</summary>
        private Nullable<TimeSpan> _Day1Start;
        /// <summary>
        /// Gets or sets Day1Start property.</summary>
        [DataObjectField(false)]
        public Nullable<TimeSpan> Day1Start
        {
            get { return _Day1Start; }
            set
            {
                if (_Day1Start == value) return;
                Nullable<TimeSpan> OldStartValue = null;
                if (_Day1Start.HasValue) OldStartValue = _Day1Start.Value;
                _Day1Start = value;
                OnPropertyChanged("Day1Start");
                if (_IsDay1TimeSynced == true) SyncStarts(_Day1Start);
                if (_Day1End.Equals(null)) Day1End = value.Value.Add(new TimeSpan(0, 30, 0));
                else if (OldStartValue.HasValue) Day1End = _Day1End.Value.Add((TimeSpan)value.Value.Subtract(OldStartValue.Value));
            }
        }
        #endregion //Day1Start

        #region Day1End
        /// <summary>
        /// Store for the Day1End property.</summary>
        private Nullable<TimeSpan> _Day1End;
        /// <summary>
        /// Gets or sets Day1End property.</summary>
        [DataObjectField(false)]
        public Nullable<TimeSpan> Day1End
        {
            get { return _Day1End; }
            set
            {
                if (_Day1End == value) return;
                _Day1End = value;
                OnPropertyChanged("Day1End");
                SyncEnds(_Day1End);
            }
        }
        #endregion //Day1End

        #region Day2Start
        /// <summary>
        /// Store for the Day2Start property.</summary>
        private Nullable<TimeSpan> _Day2Start;
        /// <summary>
        /// Gets or sets Day2Start property.</summary>
        [DataObjectField(false)]
        public Nullable<TimeSpan> Day2Start
        {
            get { return _Day2Start; }
            set
            {
                if (_Day2Start == value) return;
                Nullable<TimeSpan> OldStartValue = null;
                if (_Day2Start.HasValue) OldStartValue = _Day2Start.Value;
                _Day2Start = value;
                OnPropertyChanged("Day2Start");
                if (_IsDay2TimeSynced == true) SyncStarts(_Day2Start);
                if (_Day2End.Equals(null)) Day2End = value.Value.Add(new TimeSpan(0, 30, 0));
                else if (OldStartValue.HasValue) Day2End = _Day2End.Value.Add((TimeSpan)value.Value.Subtract(OldStartValue.Value));
            }
        }
        #endregion //Day2Start

        #region Day2End
        /// <summary>
        /// Store for the Day2End property.</summary>
        private Nullable<TimeSpan> _Day2End;
        /// <summary>
        /// Gets or sets Day2End property.</summary>
        [DataObjectField(false)]
        public Nullable<TimeSpan> Day2End
        {
            get { return _Day2End; }
            set
            {
                if (_Day2End == value) return;
                _Day2End = value;
                OnPropertyChanged("Day2End");
                SyncEnds(_Day2End);
            }
        }
        #endregion //Day2End

        #region Day3Start
        /// <summary>
        /// Store for the Day3Start property.</summary>
        private Nullable<TimeSpan> _Day3Start;
        /// <summary>
        /// Gets or sets Day3Start property.</summary>
        [DataObjectField(false)]
        public Nullable<TimeSpan> Day3Start
        {
            get { return _Day3Start; }
            set
            {
                if (_Day3Start == value) return;
                Nullable<TimeSpan> OldStartValue = null;
                if (_Day3Start.HasValue) OldStartValue = _Day3Start.Value;
                _Day3Start = value;
                OnPropertyChanged("Day3Start");
                if (_IsDay3TimeSynced == true) SyncStarts(_Day3Start);
                if (_Day3End.Equals(null)) Day3End = value.Value.Add(new TimeSpan(0, 30, 0));
                else if (OldStartValue.HasValue) Day3End = _Day3End.Value.Add((TimeSpan)value.Value.Subtract(OldStartValue.Value));
            }
        }
        #endregion //Day3Start

        #region Day3End
        /// <summary>
        /// Store for the Day3End property.</summary>
        private Nullable<TimeSpan> _Day3End;
        /// <summary>
        /// Gets or sets Day3End property.</summary>
        [DataObjectField(false)]
        public Nullable<TimeSpan> Day3End
        {
            get { return _Day3End; }
            set
            {
                if (_Day3End == value) return;
                _Day3End = value;
                OnPropertyChanged("Day3End");
                SyncEnds(_Day3End);
            }
        }
        #endregion //Day3End

        #region Day4Start
        /// <summary>
        /// Store for the Day4Start property.</summary>
        private Nullable<TimeSpan> _Day4Start;
        /// <summary>
        /// Gets or sets Day4Start property.</summary>
        [DataObjectField(false)]
        public Nullable<TimeSpan> Day4Start
        {
            get { return _Day4Start; }
            set
            {
                if (_Day4Start == value) return;
                Nullable<TimeSpan> OldStartValue = null;
                if (_Day4Start.HasValue) OldStartValue = _Day4Start.Value;
                _Day4Start = value;
                OnPropertyChanged("Day4Start");
                if (_IsDay4TimeSynced == true) SyncStarts(_Day4Start);
                if (_Day4End.Equals(null)) Day4End = value.Value.Add(new TimeSpan(0, 30, 0));
                else if (OldStartValue.HasValue) Day4End = _Day4End.Value.Add((TimeSpan)value.Value.Subtract(OldStartValue.Value));
            }
        }
        #endregion //Day4Start

        #region Day4End
        /// <summary>
        /// Store for the Day4End property.</summary>
        private Nullable<TimeSpan> _Day4End;
        /// <summary>
        /// Gets or sets Day4End property.</summary>
        [DataObjectField(false)]
        public Nullable<TimeSpan> Day4End
        {
            get { return _Day4End; }
            set
            {
                if (_Day4End == value) return;
                _Day4End = value;
                OnPropertyChanged("Day4End");
                SyncEnds(_Day4End);
            }
        }
        #endregion //Day4End

        #region Day5Start
        /// <summary>
        /// Store for the Day5Start property.</summary>
        private Nullable<TimeSpan> _Day5Start;
        /// <summary>
        /// Gets or sets Day5Start property.</summary>
        [DataObjectField(false)]
        public Nullable<TimeSpan> Day5Start
        {
            get { return _Day5Start; }
            set
            {
                if (_Day5Start == value) return;
                Nullable<TimeSpan> OldStartValue = null;
                if (_Day5Start.HasValue) OldStartValue = _Day5Start.Value;
                _Day5Start = value;
                OnPropertyChanged("Day5Start");
                if (_IsDay5TimeSynced == true) SyncStarts(_Day5Start);
                if (_Day5End.Equals(null)) Day5End = value.Value.Add(new TimeSpan(0, 30, 0));
                else if (OldStartValue.HasValue) Day5End = _Day5End.Value.Add((TimeSpan)value.Value.Subtract(OldStartValue.Value));
            }
        }
        #endregion //Day5Start

        #region Day5End
        /// <summary>
        /// Store for the Day5End property.</summary>
        private Nullable<TimeSpan> _Day5End;
        /// <summary>
        /// Gets or sets Day5End property.</summary>
        [DataObjectField(false)]
        public Nullable<TimeSpan> Day5End
        {
            get { return _Day5End; }
            set
            {
                if (_Day5End == value) return;
                _Day5End = value;
                OnPropertyChanged("Day5End");
                SyncEnds(_Day5End);
            }
        }
        #endregion //Day5End

        #region Day6Start
        /// <summary>
        /// Store for the Day6Start property.</summary>
        private Nullable<TimeSpan> _Day6Start;
        /// <summary>
        /// Gets or sets Day6Start property.</summary>
        [DataObjectField(false)]
        public Nullable<TimeSpan> Day6Start
        {
            get { return _Day6Start; }
            set
            {
                if (_Day6Start == value) return;
                Nullable<TimeSpan> OldStartValue = null;
                if (_Day6Start.HasValue) OldStartValue = _Day6Start.Value;
                _Day6Start = value;
                OnPropertyChanged("Day6Start");
                if (_IsDay6TimeSynced == true) SyncStarts(_Day6Start);
                if (_Day6End.Equals(null)) Day6End = value.Value.Add(new TimeSpan(0, 30, 0));
                else if (OldStartValue.HasValue) Day6End = _Day6End.Value.Add((TimeSpan)value.Value.Subtract(OldStartValue.Value));
            }
        }
        #endregion //Day6Start

        #region Day6End
        /// <summary>
        /// Store for the Day6End property.</summary>
        private Nullable<TimeSpan> _Day6End;
        /// <summary>
        /// Gets or sets Day6End property.</summary>
        [DataObjectField(false)]
        public Nullable<TimeSpan> Day6End
        {
            get { return _Day6End; }
            set
            {
                if (_Day6End == value) return;
                _Day6End = value;
                OnPropertyChanged("Day6End");
                SyncEnds(_Day6End);
            }
        }
        #endregion //Day6End

        #region Day7Start
        /// <summary>
        /// Store for the Day7Start property.</summary>
        private Nullable<TimeSpan> _Day7Start;
        /// <summary>
        /// Gets or sets Day7Start property.</summary>
        [DataObjectField(false)]
        public Nullable<TimeSpan> Day7Start
        {
            get { return _Day7Start; }
            set
            {
                if (_Day7Start == value) return;
                Nullable<TimeSpan> OldStartValue = null;
                if (_Day7Start.HasValue) OldStartValue = _Day7Start.Value;
                _Day7Start = value;
                OnPropertyChanged("Day7Start");
                if (_IsDay7TimeSynced == true) SyncStarts(_Day7Start);
                if (_Day7End.Equals(null)) Day7End = value.Value.Add(new TimeSpan(0, 30, 0));
                else if (OldStartValue.HasValue) Day7End = _Day7End.Value.Add((TimeSpan)value.Value.Subtract(OldStartValue.Value));
            }
        }
        #endregion //Day7Start

        #region Day7End
        /// <summary>
        /// Store for the Day7End property.</summary>
        private Nullable<TimeSpan> _Day7End;
        /// <summary>
        /// Gets or sets Day7End property.</summary>
        [DataObjectField(false)]
        public Nullable<TimeSpan> Day7End
        {
            get { return _Day7End; }
            set
            {
                if (_Day7End == value) return;
                _Day7End = value;
                OnPropertyChanged("Day7End");
                SyncEnds(_Day7End);
            }
        }
        #endregion //Day7End

        #region IsStartOfSchool
        /// <summary>
        /// Store for the IsStartOfSchool property.</summary>
        private Boolean _IsStartOfSchool;
        /// <summary>
        /// Gets or sets IsStartOfSchool property.</summary>
        [DataObjectField(false)]
        public Boolean IsStartOfSchool
        {
            get { return _IsStartOfSchool; }
            set
            {
                if (_IsStartOfSchool == value) return;
                _IsStartOfSchool = value;
                OnPropertyChanged("IsStartOfSchool");
                if (value == true) SetStartType("IsStartOfSchool");
            }
        }
        #endregion //IsStartOfSchool

        #region IsStartDate
        /// <summary>
        /// Store for the IsStartDate property.</summary>
        private Boolean _IsStartDate;
        /// <summary>
        /// Gets or sets IsStartDate property.</summary>
        [DataObjectField(false)]
        public Boolean IsStartDate
        {
            get { return _IsStartDate; }
            set
            {
                if (_IsStartDate == value) return;
                _IsStartDate = value;
                OnPropertyChanged("IsStartDate");
                if (value == true) SetStartType("IsStartDate");
            }
        }
        #endregion //IsStartDate

        #region StartDate
        /// <summary>
        /// Store for the StartDate property.</summary>
        private Nullable<DateTime> _StartDate;
        /// <summary>
        /// Gets or sets StartDate property.</summary>
        [DataObjectField(false)]
        public Nullable<DateTime> StartDate
        {
            get { return _StartDate; }
            set
            {
                if (_StartDate == value) return;
                _StartDate = value;
                OnPropertyChanged("StartDate");
            }
        }
        #endregion //StartDate

        #region IsStartMarkingPeriod
        /// <summary>
        /// Store for the IsStartMarkingPeriod property.</summary>
        private Boolean _IsStartMarkingPeriod;
        /// <summary>
        /// Gets or sets IsStartMarkingPeriod property.</summary>
        [DataObjectField(false)]
        public Boolean IsStartMarkingPeriod
        {
            get { return _IsStartMarkingPeriod; }
            set
            {
                if (_IsStartMarkingPeriod == value) return;
                _IsStartMarkingPeriod = value;
                OnPropertyChanged("IsStartMarkingPeriod");
                if (value == true) SetStartType("IsStartMarkingPeriod");
            }
        }
        #endregion //IsStartMarkingPeriod

        #region StartMarkingPeriod
        /// <summary>
        /// Store for the StartMarkingPeriod property.</summary>
        private Nullable<Int32> _StartMarkingPeriod;
        /// <summary>
        /// Gets or sets StartMarkingPeriod property.</summary>
        [DataObjectField(false)]
        public Nullable<Int32> StartMarkingPeriod
        {
            get { return _StartMarkingPeriod; }
            set
            {
                if (_StartMarkingPeriod == value) return;
                _StartMarkingPeriod = value;
                OnPropertyChanged("StartMarkingPeriod");
            }
        }
        #endregion //StartMarkingPeriod

        #region IsEndOfSchool
        /// <summary>
        /// Store for the IsEndOfSchool property.</summary>
        private Boolean _IsEndOfSchool;
        /// <summary>
        /// Gets or sets IsEndOfSchool property.</summary>
        [DataObjectField(false)]
        public Boolean IsEndOfSchool
        {
            get { return _IsEndOfSchool; }
            set
            {
                if (_IsEndOfSchool == value) return;
                _IsEndOfSchool = value;
                OnPropertyChanged("IsEndOfSchool");
                if (value == true) SetEndType("IsEndOfSchool");
            }
        }
        #endregion //IsEndOfSchool

        #region IsEndDate
        /// <summary>
        /// Store for the IsEndDate property.</summary>
        private Boolean _IsEndDate;
        /// <summary>
        /// Gets or sets IsEndDate property.</summary>
        [DataObjectField(false)]
        public Boolean IsEndDate
        {
            get { return _IsEndDate; }
            set
            {
                if (_IsEndDate == value) return;
                _IsEndDate = value;
                OnPropertyChanged("IsEndDate");
                if (value == true) SetEndType("IsEndDate");
            }
        }
        #endregion //IsEndDate

        #region EndDate
        /// <summary>
        /// Store for the EndDate property.</summary>
        private Nullable<DateTime> _EndDate;
        /// <summary>
        /// Gets or sets EndDate property.</summary>
        [DataObjectField(false)]
        public Nullable<DateTime> EndDate
        {
            get { return _EndDate; }
            set
            {
                if (_EndDate == value) return;
                _EndDate = value;
                OnPropertyChanged("EndDate");
            }
        }
        #endregion //EndDate

        #region IsEndMarkingPeriod
        /// <summary>
        /// Store for the IsEndMarkingPeriod property.</summary>
        private Boolean _IsEndMarkingPeriod;
        /// <summary>
        /// Gets or sets IsEndMarkingPeriod property.</summary>
        [DataObjectField(false)]
        public Boolean IsEndMarkingPeriod
        {
            get { return _IsEndMarkingPeriod; }
            set
            {
                if (_IsEndMarkingPeriod == value) return;
                _IsEndMarkingPeriod = value;
                OnPropertyChanged("IsEndMarkingPeriod");
                if (value == true) SetEndType("IsEndMarkingPeriod");
            }
        }
        #endregion //IsEndMarkingPeriod

        #region EndMarkingPeriod
        /// <summary>
        /// Store for the EndMarkingPeriod property.</summary>
        private Nullable<Int32> _EndMarkingPeriod;
        /// <summary>
        /// Gets or sets EndMarkingPeriod property.</summary>
        [DataObjectField(false)]
        public Nullable<Int32> EndMarkingPeriod
        {
            get { return _EndMarkingPeriod; }
            set
            {
                if (_EndMarkingPeriod == value) return;
                _EndMarkingPeriod = value;
                OnPropertyChanged("EndMarkingPeriod");
            }
        }
        #endregion //EndMarkingPeriod

        #endregion //Properties

        #region IDataErrorInfo Members

        public string Error
        {
            get
            {
                String ErrorList = "";
                if (String.IsNullOrWhiteSpace(_Id)) ErrorList += "Unique Id is required." + Environment.NewLine;
                if (String.IsNullOrWhiteSpace(_CourseId)) ErrorList += "CourseId is required" + Environment.NewLine;
                if (!_IsStartDate.Equals(null) && _IsStartDate == true && StartDate == null) ErrorList += "Starting Date is required when Start on Date is selected" + Environment.NewLine;
                if (!_IsStartMarkingPeriod.Equals(null) && _IsStartMarkingPeriod == true && StartMarkingPeriod == null) ErrorList += "Starting Marking Period is required when Start on Marking Period is selected" + Environment.NewLine;
                if (!_IsEndDate.Equals(null) && _IsEndDate == true && EndDate == null) ErrorList += "Ending Date is required when End on Date is selected" + Environment.NewLine;
                if (!_IsEndMarkingPeriod.Equals(null) && _IsEndMarkingPeriod == true && EndMarkingPeriod == null) ErrorList += "Ending Marking Period is required when End on Marking Period is selected" + Environment.NewLine;
                if (String.IsNullOrWhiteSpace(ErrorList)) return null;
                else return ErrorList;
            }
        }

        public string this[string PropertyName]
        {
            get
            {
                if (PropertyName == "Id")
                {
                    if (string.IsNullOrEmpty(_Id))
                        return "Enter a unique " + PropertyName;
                }
                if (PropertyName == "StartDate")
                {
                    if (!_IsStartDate.Equals(null) && _IsStartDate == true && StartDate == null)
                        return "Select a Start Date";
                }
                if (PropertyName == "StartMarkingPeriod")
                {
                    if (!_IsStartMarkingPeriod.Equals(null) && _IsStartMarkingPeriod == true && StartMarkingPeriod == null)
                        return "Enter the Starting Marking Period";
                }
                if (PropertyName == "EndDate")
                {
                    if (!_IsEndDate.Equals(null) && _IsEndDate == true && EndDate == null)
                        return "Select an End Date";
                }
                if (PropertyName == "EndMarkingPeriod")
                {
                    if (!_IsEndMarkingPeriod.Equals(null) && _IsEndMarkingPeriod == true && EndMarkingPeriod == null)
                        return "Enter the Ending Marking Period";
                }
                return null;
            }
        }

        #endregion

        #region Methods

        private void SetStartType(String PropertyName)
        {
            if (PropertyName != "IsStartOfSchool") IsStartOfSchool = false;
            if (PropertyName != "IsStartDate") IsStartDate = false;
            if (PropertyName != "IsStartMarkingPeriod") IsStartMarkingPeriod = false;
            OnPropertyChanged("StartDate");
            OnPropertyChanged("StartMarkingPeriod");
        }

        private void SetEndType(String PropertyName)
        {
            if (PropertyName != "IsEndOfSchool") IsEndOfSchool = false;
            if (PropertyName != "IsEndDate") IsEndDate = false;
            if (PropertyName != "IsEndMarkingPeriod") IsEndMarkingPeriod = false;
            OnPropertyChanged("EndDate");
            OnPropertyChanged("EndMarkingPeriod");
        }

        #region SyncTime
        Boolean SyncingTimes;
        private void SyncStarts(Nullable<TimeSpan> Start)
        {
            if (SyncingTimes == true) return;
            SyncingTimes = true;
            if (_IsDay1TimeSynced == true)
                Day1Start = Start;
            if (_IsDay2TimeSynced == true)
                Day2Start = Start;
            if (_IsDay3TimeSynced == true)
                Day3Start = Start;
            if (_IsDay4TimeSynced == true)
                Day4Start = Start;
            if (_IsDay5TimeSynced == true)
                Day5Start = Start;
            if (_IsDay6TimeSynced == true)
                Day6Start = Start;
            if (_IsDay7TimeSynced == true)
                Day7Start = Start;
            SyncingTimes = false;
        }

        private void SyncEnds(Nullable<TimeSpan> End)
        {
            if (SyncingTimes == true) return;
            SyncingTimes = true;
            if (_IsDay1TimeSynced == true)
                Day1End = End;
            if (_IsDay2TimeSynced == true)
                Day2End = End;
            if (_IsDay3TimeSynced == true)
                Day3End = End;
            if (_IsDay4TimeSynced == true)
                Day4End = End;
            if (_IsDay5TimeSynced == true)
                Day5End = End;
            if (_IsDay6TimeSynced == true)
                Day6End = End;
            if (_IsDay7TimeSynced == true)
                Day7End = End;
            SyncingTimes = false;
        }

        #endregion //SyncTime
        
        #endregion //Methods
    }
}
